<?php
 /*
    Plugin Name: CanvaKala Pro
    Plugin URI: http://www.canvakala.com
    Description: Complete Image Editor plugin inside your WordPress. Finds free images online.
    Author: Raul Mellado
    Version: 1.56
    Author URI: http://www.raulmellado.com
 */

// Constants
define( 'WPBEAUTIFY_VERSION', '1.56' );
if (!isset($wp_version))
    global $wp_version;
define( 'WPBEAUTIFY_WPVERSION', $wp_version );

define( 'WPBEAUTIFY_PLUGIN_NAME', dirname(plugin_basename(__FILE__) ));
define( 'WPBEAUTIFY_DIR', plugin_dir_path( __FILE__ ) );
define( 'WPBEAUTIFY_URL', plugins_url( WPBEAUTIFY_PLUGIN_NAME ) );

/* Automatic Updates */
require WPBEAUTIFY_DIR.'/lib/plugin-update-checker.php';
$wpbeautify_update_checker = new PluginUpdateChecker_1_6(
    // 'http://canvakala.s3.amazonaws.com/plugin-updates/1-std/info_canvakala1.json',
    'http://canvakala.s3.amazonaws.com/plugin-updates/2-pro/info_canvakala2.json',
    // 'http://canvakala.s3.amazonaws.com/plugin-updates/3-std-dev/info_canvakala3.json',
    // 'http://canvakala.s3.amazonaws.com/plugin-updates/4-pro-dev/info_canvakala4.json',
    WPBEAUTIFY_DIR.WPBEAUTIFY_PLUGIN_NAME.'.php'
);


/********************/

require WPBEAUTIFY_DIR.'/lib/utils.php';
if (is_admin())
	require WPBEAUTIFY_DIR.'/lib/ui.php';

require WPBEAUTIFY_DIR.'/lib/images.php';
require WPBEAUTIFY_DIR.'/lib/imageapis/imageapis.php';

    require WPBEAUTIFY_DIR.'/lib/fonts.php';
if ( ckala_is_pro() ) {
    require WPBEAUTIFY_DIR.'/lib/video.php';
    add_action( 'wp_enqueue_scripts', 'wpbeautify_front_styles' );
}

require WPBEAUTIFY_DIR.'/lib/social/social_apis.php';


function wpbeautify_front_styles()
{
    if (is_admin()) return;
    wp_register_style('wpbeautify_front', WPBEAUTIFY_URL . '/css/wpbeautify-front.css');
    wp_enqueue_style( 'wpbeautify_front' );
}

?>