<?php


/* Activation & Deactivation */
register_activation_hook(  __FILE__, 'wpbeautify_activate');
register_deactivation_hook(  __FILE__, 'wpbeautify_deactivate');
/*****************************/


function wpbeautify_check_upgrade_db() {
	if ( !get_option('wpbeautify_version', 0))  {
		// we assume we are on 1.0
		update_option('wpbeautify_version', WPBEAUTIFY_VERSION);
	}
	else {
		//do nothing for now
	}

}
add_action('admin_init', 'wpbeautify_check_upgrade_db');


function wpbeautify_activate()
{
	return;
}

function wpbeautify_deactivate() {
}

add_filter( 'plugin_action_links_' . WPBEAUTIFY_PLUGIN_NAME.'/'.WPBEAUTIFY_PLUGIN_NAME.'.php', 'wpbeautify_add_plugin_action_links' );
function wpbeautify_add_plugin_action_links( $links ) {
	return array_merge(
		$links,
		array(
			'Support' => '<a target="_blank" href="http://www.canvakala.com/support">Support</a>'
		)
	);
}

function wpbeautify_listify_pagination($pagination_array, $extra_class='') {
	// var_dump($pagination_array);
	$str_ret = '<ul class="pagination '.$extra_class.'" style="margin:0">';
	 // var_dump($pagination_array);
	if ($pagination_array) {
		foreach ($pagination_array as $pagination_item) {
			if (strpos($pagination_item,'current') !== false)
				$str_ret .= '<li class="active">'.$pagination_item.'</li>';
			else
				$str_ret .= '<li>'.$pagination_item.'</li>';
		}
	}
	$str_ret .= '</ul>';
	return $str_ret;
}


/**
    * Remove a value from a array
    * @param string $val
    * @param array $arr
    * @return array $array_remval
    */
    function wpbeautify_array_removal($val, &$arr)
    {
          $array_remval = $arr;
          for($x=0;$x<count($array_remval);$x++)
          {
              $i=array_search($val,$array_remval);
              if (is_numeric($i)) {
                  $array_temp  = array_slice($array_remval, 0, $i );
                $array_temp2 = array_slice($array_remval, $i+1, count($array_remval)-1 );
                $array_remval = array_merge($array_temp, $array_temp2);
              }
          }
          return $array_remval;
    }

function wpbeautify_site_url() {
  $protocol = ((!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off') ||
    $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
  $domainName = $_SERVER['HTTP_HOST'];
  return $protocol.$domainName;
}

define( 'CANVAKALA_IS_PRO', 1 );

function ckala_is_pro() {
	return true;// isset( CANVAKALA_IS_PRO );
}
?>